import random
from datetime import datetime

# AsteroidsRingMaker
# by JackDole
# converted to Python and enhanced by FaceDeer
# 2016.03.16 20:05:00

#uncomment this line if you want repeatable results
#random.seed(100)

# ObjectType = Asteroid or Comet
ObjectType = raw_input("Type of object (Asteroid or Comet) - Default = Asteroid : ")
if ObjectType != 'Asteroid' and ObjectType != 'Comet':
    ObjectType = 'Asteroid'
print ObjectType


# Amount of asteroids
NumberOfAster = raw_input("Number of asteroids - Default = 200 : ")
if NumberOfAster == '':
    NumberOfAster = 200
NumberOfAster = int(NumberOfAster)
print NumberOfAster


# Name of the asteroids - a serial number is appended
AsterName = raw_input("Aster name - Default = S : ")
if AsterName == '':
    AsterName = 'S'
print AsterName


# Center object
RingCenter=raw_input("Ring center - Default = Sol : ")
if RingCenter == '':
    RingCenter = 'Sol'
print RingCenter


# Orbital radii in AU
InnerRadius = raw_input("Inner Radius in AU - Default = 5.0 : ")
if InnerRadius == '':
    InnerRadius = 5.0
InnerRadius = float(InnerRadius)
print InnerRadius

OuterRadius = raw_input("Outer radius in AU - Default = 6.0 : ")
if OuterRadius == '':
    OuterRadius = 6.0
OuterRadius = float(OuterRadius)
print OuterRadius


# Radius of asteroids in KM
MaxRadiusOfAster = raw_input("Max radius in km - Default = 50.0 : ")
if MaxRadiusOfAster == '':
    MaxRadiusOfAster = 50.0
MaxRadiusOfAster = float(MaxRadiusOfAster)
print MaxRadiusOfAster

MinRadiusOfAster = raw_input("Min radius in km - Default = 0.1 : ")
if MinRadiusOfAster == '':
    MinRadiusOfAster = 0.1
MinRadiusOfAster = float(MinRadiusOfAster)
print MinRadiusOfAster


#orbital eccentricity
MaxEccentricity = raw_input("Max eccentricity - Default = 0.1 : ")
if MaxEccentricity == '':
    MaxEccentricity = 0.1
MaxEccentricity = float(MaxEccentricity)
print MaxEccentricity

MinEccentricity = raw_input("Min eccentricity - Default = 0.0 : ")
if MinEccentricity == '':
    MinEccentricity = 0.1
MinEccentricity = float(MinEccentricity)
print MinEccentricity


# Orbital inclination +- in degrees
MaxInclination = raw_input("Max inclination in degrees - Default = 10.0 : ")
if MaxInclination == '':
    MaxInclination = 10.0
MaxInclination = float(MaxInclination)
print MaxInclination


# Refplane
RefPlane = raw_input("RefPlane (Ecliptic, Equator, Extrasolar) - Default = Ecliptic : ")
if RefPlane == '':
    RefPlane = 'Ecliptic'
print RefPlane


# Epoch
epoch = raw_input("Epoch - Default = 2457395.5 : ")
if epoch == '':
    epoch = 2457395.5
epoch = float(MaxInclination)
print epoch


#FileName
FileName = raw_input("Output file name - Default = AsterRing : ")
if FileName == '':
    FileName = 'Astering'
FileName= '{0}_{1}.sc'.format(FileName, NumberOfAster)
print FileName


template ="""
{ObjectType} "{AsterName} {count}"
{{
\tParentBody\t"{RingCenter}"
\tClass\t\t"Asteroid"
\tRadius\t\t{radius}
\t
\tOrbit
\t{{
\t\tEpoch\t\t\t{epoch}
\t\tSemiMajorAxis\t{semi}
\t\tEccentricity\t{eccen}
\t\tInclination\t\t{incl}
\t\tAscendingNode\t{ascen}
\t\tArgOfPericen\t{argof}
\t\tMeanAnomaly\t\t0.0
\t\tRefPlane\t\t"{RefPlane}"
\t}}
}}

"""

#three different random number generators that give a floating point number between
#the two parameters but with different distributions

def uniform(a, b):
    return random.uniform(a, b)

def triangular(a, b):
    return random.triangular(a, b, (a+b)/2.0)

# A normal distribution placing a and b at three standard deviations out from the mean
# clamping the result so that there are no outliers beyond the desired range
def gaussian(a, b):
    result = random.gauss((a+b)/2.0, (b-a)/6.0)
    return max(min(result, b), a)

randomGenerator = gaussian

parameters = {'AsterName' : AsterName, 'RingCenter' : RingCenter, 'RefPlane' : RefPlane, 'epoch' : epoch}

with open(FileName, 'w') as outputfile:
    outputfile.write('// Asteroids made with AsteroidsRingMaker\n// {0}\n\n'.format(datetime.today()))

    for count in range(NumberOfAster):

        parameters['ObjectType'] = ObjectType
        parameters['count'] = count
        parameters['semi'] = randomGenerator(InnerRadius, OuterRadius)
        parameters['radius'] = randomGenerator(MinRadiusOfAster, MaxRadiusOfAster)
        parameters['incl'] = randomGenerator(-MaxInclination, MaxInclination)
        parameters['eccen'] = randomGenerator(MinEccentricity, MaxEccentricity)
        parameters['argof'] = random.uniform(0,360)
        parameters['ascen'] = random.uniform(0,360)

        outputfile.write(template.format(**parameters))
        

